/* mpi_bc.h - user include file for MPI programs, with no dependencies */

#ifndef _MPI_INCLUDE_BC
#define _MPI_INCLUDE_BC

/* assorted defined constants */

/* return codes */
#define MPI_OK          0
#define MPI_EXAUSTED    1
#define MPI_INVALID_TAG 2

/* Generic error handling code.  This handles inserting the file and line
   number (in MPI) where the error occured */
#define MPIR_ERROR(comm,code,string) \
    MPIR_Error( comm, code, string, __FILE__, __LINE__ )
    
/* communication modes */
typedef enum { 
    MPI_STANDARD = 0, 
    MPI_READY, 
    MPI_SYNCHRONOUS, 
    MPI_RECV 
} MPI_MODE;

#define MPI_BOTTOM      0

#define MPI_PROCNULL   -1

typedef enum {
    MPI_PERSISTENT = 0,
    MPI_EPHEMERAL
} MPI_PERSISTENCE;

typedef void *MPI_BUFFER;

typedef struct { 
    int count;
    int source;
    int tag;
} MPI_STATUS;

#endif

